=== debian/changelog ===
cppmyth-dmo (2.14.6-dmo0+deb11u1) stable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 06 Feb 2022 15:10:01 +0100

cppmyth-dmo (2.14.5-dmo0+deb11u1) stable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 13 Jan 2022 11:52:20 +0100

cppmyth-dmo (2.14.3-dmo0+deb11u1) stable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 09 Jan 2022 08:57:27 +0100

cppmyth-dmo (2.14.2-dmo0+deb11u1) stable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 08 Jan 2022 09:14:06 +0100

cppmyth-dmo (2.14.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sun, 07 Mar 2021 01:40:03 +0100

cppmyth-dmo (2.14.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 23 Jan 2021 15:59:19 +0100

cppmyth-dmo (2.13.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 09 Jan 2020 20:20:48 +0100

cppmyth-dmo (2.12.7-dmo2) unstable; urgency=medium

  * Add Multi-Arch: same for libcppmyth2 and libcppmyth-dev packages.
  * Add a cppmyth-doc package

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 12 Oct 2019 09:45:29 +0200

cppmyth-dmo (2.12.7-dmo1) unstable; urgency=medium

  * Initial release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 02 Oct 2019 07:55:56 +0200
