=== debian/control ===
Source: cppmyth-dmo
Section: libs
Priority: optional
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://janbar.github.io/cppmyth/
Standards-Version: 4.5.1
Build-Depends-Indep: doxygen
Build-Depends: debhelper-compat (= 13), cmake, ninja-build, zlib1g-dev

Package: libcppmyth2
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library to interoperate with MythTV server - runtime files
 easy client interface for the MythTV backend. Its development started from
 january 2014 and today the API supports the protocol version of MythTV 0.26
 to 29.

Package: libcppmyth-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcppmyth2 (= ${binary:Version}), ${misc:Depends}
Description: Library to interoperate with MythTV server - devel files
 easy client interface for the MythTV backend. Its development started from
 january 2014 and today the API supports the protocol version of MythTV 0.26
 to 29.

Package: cppmyth-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Library to interoperate with MythTV server - documentation files
 easy client interface for the MythTV backend. Its development started from
 january 2014 and today the API supports the protocol version of MythTV 0.26
 to 29.
 .
 This package contains the html doxygen documentation of the cppmyth API.
