=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake+ninja --without autoreconf

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release -DBUILD_SHARED_LIBS=1

#	exit 1

override_dh_auto_build-arch:
	dh_auto_build

override_dh_auto_build-indep:
	doxygen $(CURDIR)/docs/doxygen-dev.cfg

override_dh_clean-indep:
	-rm -rf doxygen-dev-docs

	dh_clean

override_dh_auto_test:
