=== debian/watch ===
version=4

https://github.com/janbar/cppmyth/tags \
(?:.*?/)?v?(\d[\d.]*)@ARCHIVE_EXT@
